<?php /*

Plugin Name: Embed-Width

Plugin URI: http://plugins.vincentastolfi.com/

Description: Allows to set custom width and height in a post or page of a video that you embed.

Author: Vincent Astolfi

Author URI: http://plugins.vincentastolfi.com

Version: 0.3.4

Open Source */

add_filter('mce_external_plugins', "embedbutton_register");
add_filter('mce_buttons', 'embedbutton_add_button', 0);

function embedbutton_add_button($buttons){
    array_push($buttons, "separator", "embedbuttonplugin");
    return $buttons;
}

function embedbutton_register($plugin_array){
    $url = trim(get_bloginfo('url'), "/")."/wp-content/plugins/embed-width/embed_button.js";

    $plugin_array['embedbuttonplugin'] = $url;
    return $plugin_array;
}

add_action('admin_menu', 'my_plugin_menu', $capability, $menu_slug, $function, 'wp-content/plugins/embed-width/eicon.png', $position);if ( isset($_POST['embed_width_updates']) ) {

		$errs = array();



		$temp = stripslashes($_POST['embed_width_updates']);



		$ev_prefix = wp_kses($temp, array());



		update_option('embed_width_updates', $ev_prefix);



}

if ( isset($_POST['embed_autoplay_updates']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_autoplay_updates']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_autoplay_updates', $ev_prefix);



}

if ( isset($_POST['embed_kioskmode_updates']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_kioskmode_updates']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_kioskmode_updates', $ev_prefix);



}

if ( isset($_POST['embed_height_updates']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_height_updates']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_height_updates', $ev_prefix);



}

if ( isset($_POST['name_sake']) ) {

		$errs = array();

		$temp = stripslashes($_POST['name_sake']);

		$ev_prefix = wp_kses($temp, array());

		update_option('name_sake', $ev_prefix);



}

if ( isset($_POST['embed_styles']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_styles']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_styles', $ev_prefix);



}

if ( isset($_POST['embed_type']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_type']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_type', $ev_prefix);



}

if ( isset($_POST['embed_description']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_description']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_description', $ev_prefix);



}

if ( isset($_POST['embed_desc_link']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_desc_link']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_desc_link', $ev_prefix);



}

if ( isset($_POST['embed_desc_link_styles']) ) {

		$errs = array();

		$temp = stripslashes($_POST['embed_desc_link_styles']);

		$ev_prefix = wp_kses($temp, array());

		update_option('embed_desc_link_styles', $ev_prefix);



}



define("WIDTHDEFAULTS", get_option('embed_width_updates').$ev_space);



define("AUTOPLAYDEFAULT", get_option('embed_autoplay_updates').$ev_space);



define("KIOSKMODEDEFAULT", get_option('embed_kioskmode_updates').$ev_space);



define("HEIGHTDEFAULTS", get_option('embed_height_updates').$ev_space);



define("EMBEDSTYLES", get_option('embed_styles').$ev_space);

define("EMBEDTYPE", get_option('embed_type').$ev_space);



define("EMBEDDESCRIPTION", get_option('embed_description').$ev_space);



define("EMBEDDESCRIPTIONLINK", get_option('embed_desc_link').$ev_space);



define("EMBEDDESCRIPTIONLINKSTYLES", get_option('embed_desc_link_styles').$ev_space);



define("icon_url", ('/eicon.png').$ev_space);



function my_plugin_menu() {



	add_menu_page('Embed Width Options', 'Embed-Width', 'manage_options', 'embed_width', 'embed_width_options', '/wp-content/plugins/embed-width/eicon.png');}function embed_width_options() {

	if (!current_user_can('manage_options'))  {



		wp_die( __('You do not have sufficient permissions to access this page.') );



	}



	echo '<div id="icon-options-general" class="icon32"></div>';



	echo '<div class="wrap" style="float:left;">';



	echo '<h2>Embed-Width Settings - A Plugin by Vincent Astolfi</h2><hr />';



	echo '</div>';



	echo '<br><br><br><br>';



	echo '<h4>Set Your Default Width and Height Below (e.x. "100" without quotes)</h4>';



	echo '<h4>You May Also set default Styles (e.x. float:right; border:1px solid #fff; (No Quotes))</h4>';

	

	echo '<h4 style="color:red;">New Options: AutoPlay and Save As. Setting true on autoplay will make your videos/music play automatically when the page loads, and false will make people click play to do so. True on the "Save As" option will disable people from being able to use the Save As feature, although there are still ways around this and it does not ensure that they will not be able to get your video/music anyway. False will allow them to download it if they would like to.</h4>';



	echo '<div>';



	echo '</div>';



	echo '';

?>


<h3>Default Video Settings:</h3>
<div class="wrap">



<form method="post">



<div>

<div style="text-align:right; float:left;"> <?php echo _e('Default Embed Type:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_type') ?>" name="embed_type" id="embed_type" />
    
    

  <div style="text-align:right; float:left;"> <?php echo _e('Default Embed Width:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_width_updates') ?>" name="embed_width_updates" id="embed_width_updates" />



    <br />



    <?php echo _e('Default Embed Height:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_height_updates') ?>" name="embed_height_updates" id="embed_height_updates" />



    <br />



    <?php echo _e('Autoplay: (true/false)','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_autoplay_updates') ?>" name="embed_autoplay_updates" id="embed_autoplay_updates" />



    <br />

    

    <?php echo _e('Turn off "Save As": (true/false)','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_kioskmode_updates') ?>" name="embed_kioskmode_updates" id="embed_kioskmode_updates" />



    <br />



    <?php echo _e('Default Embed Styles:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_styles') ?>" name="embed_styles" id="embed_styles" />



    <br />



    <hr />



    <?php echo _e('Embed Description:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_description') ?>" name="embed_description" id="embed_description" />



    <br />



    <?php echo _e('Embed Description Link:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_desc_link') ?>" name="embed_desc_link" id="embed_desc_link" />



    <br />



    <?php echo _e('Description Styles:','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('embed_desc_link_styles') ?>" name="embed_desc_link_styles" id="embed_desc_link_styles" />



    <br />



    <?php echo _e('What Is Your Name?','embeddedvideo'); ?>



    <input type="text" value="<?php echo get_option('name_sake') ?>" name="name_sake" id="name_sake" />



    <br />



    <div>



<br  />
<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=J3TB85RRL9TZG&lc=US&item_name=Vincent%20Astolfi%20Creative&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted"><img src="/wp-content/plugins/embed-width/btn_donateCC_LG.gif" /></a>


      <p>Thank You For Your Support <?php echo get_option('name_sake') ?></p>
      


    </div>



  </div>



  <input type="submit"  id="embeddedvideo_update_options" value="<?php echo _e('Save Options','embeddedvideo'); ?> &raquo;" />



</div>



<div class="info" style="float:right; text-align:left;">



  <hr />



  <h2>Information</h2>



  <p>This Plugin supports a few different Video Types, Including (but not limited to) <strong>M4V, Quicktime, SWF, and Youtube.</strong> It works as an embedder, so basically any site that provides an Embed Code will work.  Below, I will provide information on how to properly use the embed links, using YouTube as an example.  Created By: Vincent Astolfi</p>



  <hr />

  <h2 style="color:red;">Support for MP3/Audio Files</h2>
  
  <p style="color:red;"> New Support for audio has recently been added. Now if you would like to enjoy using this plugin for audio, it's quite simple. Your shortcode will look like this: [embedwidth src="Link Here" type="auto/mpeg"]</p>
  <p> This was added because it came to my attention that when trying to turn off autoplay in google chrome with my plugin, the music would start playing automatically. This is because we need to tell Chrome that we're using an audio file, not a video file. If you use only videos, don't worry. Just leave the above box blank, and don't use the "type" tag in your shortcode. If you use mp3's more often than not, just put auto/mpeg in the box labeled "Default Embed Type" above.
  

  <h2>Set Up & Use</h2>



  <p><h4>New Update: Autoplay options. Simply set true or false above and your videos will either begin playing when someone reaches the page (true) or only start when they click play (false). Also add it in the shortcode: [embedwidth src="http://mylink.com" autoplay="true"]</h4></p>



  <p>The Set-Up Is quite Simple Actually.  Once the plugin is installed it is ready to go.  You can set a default width and height above if you often upload videos of simmilar size.  All you have to do after that is input this shortcode into the content area of your posts or pages:</p>



  <p><strong>[embedwidth src="Insert Video Link Here"]</strong></p>



  <p>And This is what It will look like with a file actually hosted on your server, such as an m4v.</p>



  <p><strong>[embedwidth src="http://www.mysite.com/wp-content/uploads/2012/02/tip_0059.m4v"]</strong></p>



  <hr />



  <h2>Setting Custom Embed Width/Height In Posts & Pages</h2>



  <p>Now, say that you do not often times upload videos of simmilar size, or just want to change the width and height of a certian video.  That can be done by just adding some extra commands into the short code.  The width an height you write in the shortcode automatically over-ride the default settings, but if nothing is in the boxes above then it will not know what size to make it unless you specify it in the shortcode.  A shortcode with custom Width and Height would look like this:</p>



  <p><strong>[embedwidth width="100" height="100" src="Insert Video Link Here"]</strong></p>



  <p>Obviously, you can change the width and height I have specified above to whatever numbers you would like.  You don't have to add "px" after your number, you can leave the value as a plain integer. </p>



  <hr />



  <h2>Setting Default & Custom Embed Styles</h2>



  <p>This Part is pretty self explanitory if you've read anything above this, but I will explain it for you just in case you havent.</p>



  <p>If you want to add default styles above, just make sure that you type them without quotation marks.</p>



  <p> An Example would be: <strong><a style="color:#F00">float:right; border:1px solid #fff;</a></strong></p>



  <p>You can use unlimited styling in this box.  But say you wanted one of your videos to have it's own seperate styling.  You can override already set styling by adding a simple style="Styles here" to your shortcode.  That would look like this:</p>



  <p><strong>[embedwidth style="<a style="color:#F00">float:right; border:1px solid #fff;</a>" src="http://www.youtube.com/embed/hIO9DLe_-rY"]</strong></p>



  <p>Obviously, you can still put in the "width" and "height" tags along with the "style" tag inside of your shortcode.  Setting width and height using the "style" tag instead of the width/height tags will not work.</p>



  <p>And Last but Not Least, you can add custom styles to the videos using your own stylesheet if you would like, the div that holds all of your embeds has a class around it.  The class is <a style="color:#E00">embedwidthstyles</a>, so you may add that to your own stylesheet if you want to add a background image or something more advanced to your video, or possibly create a frame.</p>



  <hr />



  <h2>Default Description/Description Link</h2>



  <p>The description will be placed below the video by default, and at this time there is no support for changing where the discription displays in a setting. If you want to change that, you will have to edit this plugin. However, there is a custom styles setting above and instructions on how to use it below. This Part is also pretty self explanitory if you've read anything above this, but I will explain it for you just in case you havent.</p>



  <p>If you want to add a default Description that links to something, it is actually quite simple. In the "Embed Description" box above, just write your default description.  If you want it to link to something, put a link (without quotation marks) into the "Embed Description Link" box and it will automatically make the Description you provided clickable.</p>



  <p>If You would like to change the description link for a specific video, in it's shortcode in the content area, you must write these commands, which will override the default settings in the Embed-Width menu.</p>



  <p>Your Shortcode Should Look Like This: <strong><a style="color:red;">[embedwidth desc="Here is My Description" desclink="http://www.mylink.com/" src="Video Embed Link Here"]</a></strong></p>



  <p>Obviously, if you do not add these tags to the shortcode the defaults will automatically show up.  If there are no defaults, nothing will show up at all.</p>



  <hr />



  <h2>Default Description Styles</h2>



  <p>The "Description Styles" box works the exact same way as the "Default Embed Styles" box.  You just write in styles and it automatically inserts them. It works wether or not there is a description link, because the href is inside of the Description Style div.  You can add margins or padding, colors, boldness, etc all in that box as long as you know how to write the code.  Refer to above for how to properly write the code in this box, because there are a couple peramaters for how it needs to work.</p>



  <p>You may also set a custom description style within the shortcode if you need a certain style for a specific video.  You can do this by doing <strong><a style="color:red;">[embedwidth descstyles="color:red;" src="Your Link Here"]</a></strong></p>



  <p>Again, these styles will ovveride the styles being sent by your defaults set in the Options above.</p>



  <hr />



  <h2>YouTube & Other Outside Sources</h2>



  <p>If you want to embed a video from a website (such as youtube) that offers an embed link, you may do so by copying the <strong>EMBED LINK</strong>, not the actual page URL, and pasting it in the src="  " part of your short-code.  I repeat, using the actual URL of the page is not (yet) supported for this plugin, and so it will not work unless you are using an embed link.</p>



  <p>If you are getting it from youtube, they give you a bit of code, and I will paste and example and highlight in red what part you will need to copy</p>



  <p><strong> &lt;iframe width="560" height="315" src="<a style="color:#F00">http://www.youtube.com/embed/hIO9DLe_-rY</a>" frameborder="0" allowfullscreen&gt; &lt;/iframe&gt;</strong></p>



  <p>And It will End Up Like this:</p>



  <p><strong>[embedwidth src="<a style="color:#F00">http://www.youtube.com/embed/hIO9DLe_-rY</a>"]</strong></p>



  <p>Do NOT have more than one quote on either side of the link, or else it will not display correctly.</p>



  <hr />



  <p style="float:left;">Developed By <strong><a href="http://www.vincentastolfi.com/" target="_blank">Vincent Astolfi</a></strong></p>



  <p style="float:right;">Created For <strong><a href="http://maclab.guhsd.net/blog/" target="_blank">The Mac Lab</a></strong></p>



</div>



<?php }

add_shortcode( 'embedwidth', 'embed_width_shortcode' );



function embed_width_shortcode( $atts, $content = null ) {



   if(isset($atts[width])){



     $embedwidth_width = $atts[width];



   }else{



     $embedwidth_width = WIDTHDEFAULTS;



   }



   



   if(isset($atts[height])){



     $embedwidth_height = $atts[height];



   }else{



     $embedwidth_height = HEIGHTDEFAULTS;



   }

   if(isset($atts[autoplay])){



     $embedwidth_autoplay = $atts[autoplay];



   }else{



     $embedwidth_autoplay = AUTOPLAYDEFAULT;



   }

   if(isset($atts[kioskmode])){



     $embedwidth_kioskmode = $atts[kioskmode];



   }else{



     $embedwidth_kioskmode = KIOSKMODEDEFAULT;



   }

   



   if(isset($atts[style])){



     $embed_styles = $atts[style];



   }else{



     $embed_styles = EMBEDSTYLES;



   }
   
   if(isset($atts[type])){



     $embed_type = $atts[type];



   }else{



     $embed_type = EMBEDTYPE;



   }



   



   if(isset($atts[desc])){



     $embed_description = $atts[desc];



   }else{



     $embed_description = EMBEDDESCRIPTION;



   }



   



   if(isset($atts[desclink])){



     $embed_description_link = $atts[desclink];



   }else{



     $embed_description_link = EMBEDDESCRIPTIONLINK;



   }



   



   if(isset($atts[descstyles])){



     $embed_description_link_styles = $atts[descstyles];



   }else{



     $embed_description_link_styles = EMBEDDESCRIPTIONLINKSTYLES;



   }



return '<div class="embedwidthstyles" style="' . $embed_styles .'"><embed type="' . $embed_type .'" src="' . $atts[src] . '" width="' . $embedwidth_width . '" height="' . $embedwidth_height . '" autostart="' . $embedwidth_autoplay . '" kioskmode=' . $embedwidth_kioskmode . ' /></div><div class="embedlinkstyles" style="' . $embed_description_link_styles . '"><a style="' . $embed_description_link_styles . '" href="' . $embed_description_link . '"><div class="embeddescription">' . $embed_description .'</div></a></div>';



}

add_action('wp_insert_post', 'embed_width_custom_fields');

function embed_width_custom_fields($post_id){



    if ( $_GET['post_type'] != 'post' ) {



     add_post_meta($post_id, 'Copy + Paste this shortcode into Content Area', '[embedwidth src=""]  Or For Non-Default Options: [embedwidth src="" width="" height="" style="" desc="" desclink="" descstyle="" autoplay="" kioskmode=""]', true);}

    return true;



}



?>